--------------------------------------------------
--Name: 	SCRIPTOONS II 
--Type: 	RenderEffect Plug-in Script
--Version:	0.62 (Release II for MAX R3)
--Changed: 	7/27/99
--Author: 	Borislav Petrov
--Email:	bobo@email.archlab.tuwien.ac.at
--Web:		http://gfxcentral.com/bobo/
--------------------------------------------------


plugin RenderEffect ScripToons 
name:"ScripToons"
classID:#(0x6543232a, 0x5436ab1c) 
(


local c_array = #()
local alpha_yes = false
local bmp_w
local bmp_h

local ambient_array = #()
local diffuse_array = #()
local specular_array = #()
local node_array = #()


Rollout last_time "Last Frame Time"
(
label last_frame "No Frames Rendered Yet." 
)
	

Rollout st_ink "Pen and Ink Settings"
(
checkbutton apply_ink "Apply Pen Ink" checked:true width:300 height:25 align:#center highlightcolor:([255,255,200] as color) \
tooltip:"Toggles Countour or Outline Pen Ink drawing..."
dropdownlist ink_type items:#("OUTLINE Pen (Node-Based)","CONTOUR Pen (Coverage-Based)") selection:2
spinner down_limit "From" range:[0,127,0] type:#integer fieldwidth:40 align:#left across:3
spinner up_limit "To" range:[128,255,255] type:#integer fieldwidth:40 align:#left 

spinner ink_size "Pen Width" range:[1,50,2] type:#integer fieldwidth:40 align:#right
colorpicker ink "Ink Color" align:#right color:[20,0,60] fieldwidth:150 align:#right

on ink_type selected itm do
(
if itm == 1 then 
	(
	up_limit.enabled = false
	down_limit.enabled = false
	)
	else
	(
	up_limit.enabled = true
	down_limit.enabled = true
	)
)
)


Rollout st_shade "Cartoon Shading - Material Colors"
(
checkbutton shade_yes "Use Solid Shading" checked:true width:300 height:25 highlightcolor:([255,255,200] as color) align:#center \
tooltip:"Toggles Standard Material + Wireframe Color Solid Shading..."
spinner ad_limit "Ambient-Diffuse Limit" range:[0,255,80] type:#integer fieldwidth:60 align:#right
spinner ds_limit "Diffuse-Specular Limit" range:[0,255,160] type:#integer fieldwidth:60 align:#right
checkbutton smooth_borders "Smooth Border Lines" checked:true width:300 align:#center highlightcolor:([200,255,200] as color) \
tooltip:"Toggles Horizontal Smoothing of Border Lines between Ambient/Diffuse/Specular color"
colorpicker bg_color "Background" color:[192,192,192] align:#right fieldwidth:150
checkbutton replace_background "Replace Background" checked:true width:300 align:#center highlightcolor:([200,255,200] as color) \
tooltip:"Toggles User Background Color Replacement"
button generate_materialid "Generate MatIDs For Multi/Sub Materials" width:300 align:#center

on generate_materialid pressed do
(
for m in scenematerials do
(
if classof m == MultiMaterial then
	(
	for n = 1 to m.numsubs do
		(
		m.materiallist[n].effectsChannel = n
		)
	)
)
)


)

Rollout about_roll "About..." rolledup:false
(

label aboutst01 "ScripToons II - Reffect Script"
label aboutst02 "Beta 0.62 - 7/27/99"
label aboutst03 "by Borislav Petrov"
label aboutst05 "http://gfxcentral.com/bobo/" 

)



on channelsRequired do
(
#(#node,#coverage,#matID)
)
		

on apply image_file do
(	
bmp_h = image_file.height 
bmp_w = image_file.width

scanstart_stamp = timeStamp ()
	
--------------------------------------------------------------------

	if st_shade.shade_yes.checked then
	(

	gc()
	gc_count = 0
	
	node_at_pixel_array = #()
	node_array = #()
	mat_type = #()
	last_pixel = undefined	
	first_node = 0
	last_node = bmp_h-1
	
	for h = 0 to bmp_h-1 do
	(
	c_array = getpixels image_file [0,h] bmp_w
	for w = 1 to bmp_w do
		(
		lum_value = (c_array[w].r + c_array[w].g + c_array[w].b) / 3.0
		node_at_pixel_array = getChannel image_file [w-1,h] #node
		node_at_pixel = node_at_pixel_array[1]
		
		if node_at_pixel != undefined and superclassof node_at_pixel == GeometryClass then 
			(
			if node_array.count == 0 then first_node = h
			last_node = h
			item_index = findItem node_array node_at_pixel
			)
			else
			(
			item_index = -1
			)
		if item_index == 0 and node_at_pixel != undefined then 
			(
			append node_array node_at_pixel
		--	print node_at_pixel_array[1]  
			item_index = node_array.count
			mat_type[item_index] = 0
			if node_at_pixel.material != undefined then
			(
				if classof node_at_pixel.material == Standardmaterial then
				(
				ambient_array[item_index] = node_at_pixel.material.ambient
				diffuse_array[item_index] = node_at_pixel.material.diffuse
				specular_array[item_index] = node_at_pixel.material.specular
				mat_type[item_index] = 1
				)
				if classof node_at_pixel.material == Multimaterial then
				(
				a_multi_array = #()
				d_multi_array = #()
				s_multi_array = #()
				for m = 1 to node_at_pixel.material.count do
				(
				a_multi_array[m] = node_at_pixel.material[m].ambient
				d_multi_array[m] = node_at_pixel.material[m].diffuse
				s_multi_array[m] = node_at_pixel.material[m].specular
				)
				ambient_array[item_index] = a_multi_array
				diffuse_array[item_index] = d_multi_array
				specular_array[item_index] = s_multi_array
				mat_type[item_index] = 2
				)
			)	
			if mat_type[item_index] == 0 then
			(
			ambient_array[item_index] = node_at_pixel.wirecolor * 0.3
			diffuse_array[item_index] = node_at_pixel.wirecolor
			specular_array[item_index] = color 255 255 255
			)
			)
	
		if node_at_pixel != undefined and superclassof node_at_pixel == GeometryClass then
		(
		if mat_type[item_index] == 2 then
		(
		matid_at_pixel_array = getChannel image_file [w-1,h] #matID
		if matid_at_pixel_array[1] == 0 then matid_at_pixel_array[1] = 1
		if matid_at_pixel_array[1] > node_at_pixel.material.count then matid_at_pixel_array[1] = node_at_pixel.material.count
		)
	
			if lum_value > st_shade.ad_limit.value and lum_value < st_shade.ds_limit.value then
				(
				if mat_type[item_index] < 2 then 
					(
					pixel_color = diffuse_array[item_index]		
					)
					else
					(
					a_array = diffuse_array[item_index]
					pixel_color = a_array[matid_at_pixel_array[1]]
					)
				)--end if diffuse
				
			if lum_value <= st_shade.ad_limit.value then
				(
				if mat_type[item_index] < 2 then 
				(
				pixel_color = ambient_array[item_index]				
				)
				else
				(
				a_array = ambient_array[item_index]
				pixel_color = a_array[matid_at_pixel_array[1]]				
				)
				)--end if ambient
				
			if lum_value >= st_shade.ds_limit.value then
				(
				if mat_type[item_index] < 2 then 
				(
				pixel_color = specular_array[item_index]		
				)
				else
				(
				a_array = specular_array[item_index]
				pixel_color = a_array[matid_at_pixel_array[1]]					
				)
				)--end if specualr			
		
		if not st_shade.smooth_borders.checked then last_pixel = pixel_color
		if last_pixel != pixel_color and pixel_color != undefined and last_pixel != undefined then 
			(
			c_array[w] = (pixel_color+last_pixel)/2.0
			)
			else
			(
			c_array[w] = pixel_color
			)
			
		last_pixel = pixel_color
		)
		else
		(
		if st_shade.replace_background.checked then 
			(
			alpha_value = c_array[w] .alpha
			c_array[w] = st_shade.bg_color.color
			c_array[w].alpha = alpha_value 
			)
		last_pixel = c_array[w]
		)
		)--end w loop
	last_pixel = undefined	
	setpixels image_file [0,h] c_array		
	)--end h loop

	
	)--end shade



	
	
	if st_ink.apply_ink.checked then
	(
	
	if st_ink.ink_type.selection == 1 then
	(
	node_channel = getChannelAsMask image_file #node
	
	ca = #()
	for i = 1 to st_ink.ink_size.value do
	(
	ca[i] = st_ink.ink.color
	)

	
	for h = first_node to last_node do
	(

	last_line = getpixels node_channel [0,h-1] bmp_w
	current_line = getpixels node_channel [0,h] bmp_w


	for w = 1 to bmp_w do
	(


	if w > 1 then 
		(
		last_point = current_line[w-1]
		)
		else 
		(
		last_point = color 0 0 0 
		)
	current_point = current_line[w]
	if w < bmp_w then
	(	
	next_point = current_line[w+1]
	)
	else
	(
	next_point = color 0 0 0 
	)
	
	if h > 1 then
	(
	up_point = last_line[w]
	)
	else
	(
	up_point = color 0 0 0 
	)
	draw_ok = false
	if w > 1 and last_point !=current_point then draw_ok = true
	if h > 1 and up_point !=current_point then draw_ok = true
	
	
	if draw_ok then
	(
		for i = 1 to st_ink.ink_size.value do
			(
			setPixels image_file [w-1-floor(st_ink.ink_size.value/2),h-floor(st_ink.ink_size.value/2)+i-1] ca
			)
	)
			
	)--end w loop
 	)--end h loop
	close node_channel
)--end ink 1
else
(

	cov_channel = getChannelAsMask image_file #coverage

	ca = #()
	for i = 1 to st_ink.ink_size.value do
	(
	ca[i] = st_ink.ink.color
	)


	for h = first_node to last_node do
	(
	current_line = getpixels cov_channel [0,h] bmp_w
	for w = 1 to bmp_w do
	(
	draw_ok = false
	if current_line[w].r < st_ink.up_limit.value and current_line[w].r > st_ink.down_limit.value then draw_ok = true
	if draw_ok then
	(
		for i = 1 to st_ink.ink_size.value do
			(
			setPixels image_file [w-1-floor(st_ink.ink_size.value/2),h-floor(st_ink.ink_size.value/2)+i-1] ca
			)
	)

	)--end w
	)--end h


)--end else ink type
)--end if ink

	scanend_stamp = timeStamp ()
	scantime = ((scanend_stamp - scanstart_stamp)as float /1000.0 )
	
	last_time.last_frame.text = ("Last Frame Processing Time: " + (scantime as string) +  " sec.")

)--end apply


)--end plug-in




